<script lang="ts">
  import Section from '$lib/components/sections/Section.svelte';
  import BaseLayout from '$lib/components/layouts/BaseLayout.svelte';
  import SsaCard from '$lib/components/cards/SsaCard.svelte';
  import type { PageData } from './$types';
  import { axiosInstance } from '$lib/config';
  import Pagination from '$lib/components/Pagination.svelte';

  export let data: PageData;

  let ssa = data?.sno.data,
    page = data.page || 1,
    pages = data?.sno.pages;

  $: {
    ssa = data?.sno.data;
    page = data.page || 1;
    pages = data?.sno.pages;
  }

  async function handleSearch(event: any) {
    const res = await axiosInstance.get('/sno', { params: { ...(event.detail && { name: event.detail }) } });

    if (event.detail) {
      pages = 0;
    } else {
      pages = data?.sno.pages;
    }

    ssa = res.data.data;
  }
</script>

<svelte:head>
    <title>Студенческие научные общества</title>
</svelte:head>

<BaseLayout>
    <Section title="Студенческие научные общества" class="mt-16" {handleSearch}>
        <section class="grid 2xl:grid-cols-3 lg:grid-cols-2 gap-8">
            {#each ssa as { id, name, description, attachment }}
                <SsaCard {id} {name} {description} {attachment}/>
            {/each}
        </section>
        <Pagination {page} {pages}/>
    </Section>
</BaseLayout>